// =============================================================================
// Parent   : BBoyShare.B_Effectors
// Package  : BBoyShare
// Class    : B_FlameGen
//
// Author   : Boom-Boy
// Homepage : http://mth.or.tp/
//
// Version  : 1.0
// =============================================================================

#exec OBJ LOAD FILE=..\Sounds\Ambancient.uax

class B_FlameGen extends B_Effectors;

var() int FlameZ;
var() float FlashGlow;
var float FlashTime;

simulated function PostBeginPlay() {
	
	super.PostBeginPlay();
	
	SetTimer(0.1, true);
}

simulated function PostNetBeginPlay() {
	
	super.PostNetBeginPlay();
	
	SetTimer(0.1, true);
}

simulated function Tick(float DT) {
	
	super.Tick(DT);
	
	FlashTime = FMax(FlashTime - DT, 0.0);
	ScaleGlow = Default.ScaleGlow + FlashTime * FlashGlow;
}

simulated function Timer() {
	
	local vector v;
	local B_FlameEffect FE;
	local int i;
	
	v = vect(0, 0, -0.5);
	FE = spawn(class'B_FlameEffect', , , Location - v * CollisionHeight / 2);
	FE.Velocity.Z = 150 + FlameZ * FlashTime;
	for (i = 0; i < 3; i++) {
		if (FRand() > 0.75) {
			v.X += Rand(2);
			v.Y += Rand(2);
		} else if (FRand() > 0.5) {
			v.X -= Rand(2);
			v.Y -= Rand(2);
		} else if (FRand() > 0.25) {
			v.X += Rand(2);
			v.Y -= Rand(2);
		} else {
			v.X -= Rand(2);
			v.Y += Rand(2);
		}
		v.Z -= 0.7;
		FE = spawn(class'B_FlameEffect', , , Location - v * CollisionHeight / 2);
		FE.Velocity.Z = 150 + FlameZ * FlashTime;
	}
}

defaultproperties
{
     FlameZ=1024
     FlashGlow=1.000000
     AmbientSound=Sound'Ambancient.Looping.afire3'
     SoundRadius=64
     SoundVolume=32
     CollisionRadius=8.000000
     CollisionHeight=8.000000
     LightType=LT_SubtlePulse
     LightEffect=LE_FireWaver
     LightBrightness=50
     LightHue=22
     LightSaturation=32
     LightRadius=32
     LightPeriod=32
     LightCone=128
     VolumeBrightness=64
}
