// =============================================================================
// Parent   : BBoyShare.B_FlameGen
// Package  : BBoyShare
// Class    : B_FlameGen2
//
// Author   : Boom-Boy
// Homepage : http://mth.or.tp/
//
// Version  : 1.0
// =============================================================================

class B_FlameGen2 extends B_FlameGen;

var() float SpawnScale;

simulated function PostBeginPlay() {
	
	super.PostBeginPlay();
	
	SetTimer(0.15, true);
}

simulated function PostNetBeginPlay() {
	
	super.PostNetBeginPlay();
	
	SetTimer(0.15, true);
}

simulated function Timer() {
	
	local vector v;
	local B_FlameEffect2 FE;
	local int i;
	
	v = vect(0, 0, -0.5);
	FE = spawn(class'B_FlameEffect2', , , Location - v * CollisionHeight / 2);
	FE.DrawScale = SpawnScale;
	FE.Velocity.Z = 100 * SpawnScale + FlameZ * FlashTime;
	
	for (i = 0; i < 2; i++) {
		if (FRand() > 0.75) {
			v.X += Rand(int(SpawnScale));
			v.Y += Rand(int(SpawnScale));
		} else if (FRand() > 0.5) {
			v.X -= Rand(int(SpawnScale));
			v.Y -= Rand(int(SpawnScale));
		} else if (FRand() > 0.25) {
			v.X += Rand(int(SpawnScale));
			v.Y -= Rand(int(SpawnScale));
		} else {
			v.X -= Rand(int(SpawnScale));
			v.Y += Rand(int(SpawnScale));
		}
		v.Z -= 0.5;
		FE = spawn(class'B_FlameEffect2', , , Location - v * CollisionHeight / 2);
		FE.DrawScale = SpawnScale;
		FE.Velocity.Z = 50 * SpawnScale + FlameZ * FlashTime;
	}
}

defaultproperties
{
     SpawnScale=1.000000
     FlameZ=256
     LightHue=27
     LightSaturation=50
}
