// =============================================================================
// Parent   : BBoyShare.B_NavigationPoint
// Package  : BBoyShare
// Class    : B_JumperPoint
//
// Author   : Boom-Boy
// Homepage : http://mth.or.tp/
//
// Version  : 1.0
// =============================================================================

class B_JumperPoint extends B_NavigationPoint;

var()	vector	JumpVelocity;
var()	float	FlashGlow;
var		float	FlashTime;

simulated function PostBeginPlay() {
	
	super.PostBeginPlay();
	
	SetRotation(Rot(16384, 0, 0));
	SetTimer(0.1, true);
}

simulated function PostNetBeginPlay() {
	
	super.PostNetBeginPlay();
	
	SetTimer(0.1, true);
}

simulated function Touch(Actor Other) {
	
	local Actor A;
	
	if (!Other.IsA('Pawn') || Other.IsA('ScriptedPawn'))
		return;
	
	PendingTouch = Other.PendingTouch;
	Other.PendingTouch = self;
}

simulated function PostTouch(Actor Other) {
	
	Other.Velocity = JumpVelocity;
	Other.SetPhysics(PHYS_Falling);
	FlashTime = 1.0;
}

simulated function Tick(float DT) {
	
	super.Tick(DT);
	
	FlashTime = FMax(FlashTime - DT, 0.0);
	ScaleGlow = Default.ScaleGlow + FlashTime * FlashGlow;
}

simulated function Timer() {
	
	local vector v;
	local B_JumperWaveEffect wave;
	local int i;
	local float f;
	
	v = vect(0, 0, 0);
	f = FRand();
	if (f > 7.5) {
		v.X += Rand(8);
		v.Y += Rand(8);
	} else if (f > 5.0) {
		v.X -= Rand(8);
		v.Y -= Rand(8);
	} else if (f > 2.5) {
		v.X += Rand(8);
		v.Y -= Rand(8);
	} else {
		v.X -= Rand(8);
		v.Y += Rand(8);
	}
	//v.Z -= Rand(8);
	//wave = spawn(class'B_JumperWaveEffect', , , Location - vect(0, 0, 1) * CollisionHeight / 2);
	wave = spawn(class'B_JumperWaveEffect', , , Location - v * CollisionHeight / 2);
	//wave.GotoState('FadeIn');
	wave.Velocity.Z = 50 + Rand(100) + JumpVelocity.Z * FlashTime;
}

defaultproperties
{
     JumpVelocity=(Z=1024.000000)
     FlashGlow=1.000000
     bUnlit=True
     CollisionRadius=32.000000
     CollisionHeight=8.000000
}
