// =============================================================================
// Parent   : BBoyShare.B_MonsterLoopSpawner
// Package  : BBoyShare
// Class    : B_MonsterWaveSpawner
//
// Author   : Boom-Boy
// Homepage : http://mth.or.tp/
//
// Version  : 1.0
// =============================================================================

class B_MonsterWaveSpawner extends B_MonsterLoopSpawner;

var(MonsterWaveSpawner) class<ScriptedPawn> WaveCreatureType[16];
var int WaveSpawnNum;
var int Wave;

simulated function PostBeginPlay() {
	
	super.PostBeginPlay();
	
	WaveSpawnNum = SpawnNum;
	Wave = 0;
	if (WaveCreatureType[Wave] == None) {
		bFinishedEvent = false;
		GotoState('Finished');
	} else {
		CreatureType = WaveCreatureType[Wave];
	}
}

State Spawning
{
	function Timer() {
		
		if (SpawnNum > 0) {
			if (TrySpawn())
				SpawnNum--;
		}
		
		if (((Wave >= 16) || (CreatureType == None)) && NumMonster == 0) {
			GotoState('Finished');
		} else {
			if (LoopTime > 0.0)
				SetTimer(LoopTime, false);
			else
				SetTimer(1.0 + FRand() + FRand(), false);
		}
	}
	
	function Trigger(Actor Other, Pawn EventInstigator) {
		
		if (Other.Event == Tag && Other.Tag == Name) {
			Instigator = EventInstigator;
			NumMonster = Max(NumMonster - 1, 0);
			if (SpawnNum == 0) {
				SpawnNum = WaveSpawnNum;
				Wave++;
				CreatureType = WaveCreatureType[Wave];
			}
		}
	}
}

defaultproperties
{
     WaveCreatureType(0)=Class'UnrealShare.Brute'
}
