// =============================================================================
// Parent   : UnrealShare.WoodenBox
// Package  : BBoyShare
// Class    : B_PawnBox
//
// Author   : Boom-Boy
// Homepage : http://mth.or.tp/
//
// Version  : 1.0
// =============================================================================

class B_PawnBox extends WoodenBox;

var(PawnBox) class<ScriptedPawn>	PawnContent;
var(PawnBox) name					P_Orders;
var(PawnBox) name					P_OrderTag;
var(PawnBox) int					P_Health;
var(PawnBox) float					P_SightRadius;
var(PawnBox) float					P_Skill;
var(PawnBox) float					P_Aggressiveness;
var(PawnBox) float					P_CombatStyle;
var(PawnBox) float					P_ReFireRate;
var(PawnBox) class<Projectile>		P_RangedProjectile;
var(PawnBox) float					P_ProjectileSpeed;
var(PawnBox) float					P_AccelRate;
var(PawnBox) float					P_GroundSpeed;
var(PawnBox) float					P_AirSpeed;
var(PawnBox) float					P_JumpZ;
var(PawnBox) float					P_WaterSpeed;
var(PawnBox) name					P_Event;

function Destroyed() {
	
	local Actor dropped;
	
	dropped = Spawn(PawnContent);
	
	if (dropped == None || ScriptedPawn(dropped) == None)
		return;
	
	dropped.RemoteRole = ROLE_SimulatedProxy;
	dropped.SetPhysics(PHYS_Falling);
	dropped.bCollideWorld = true;
	
	if (P_Orders != '')
		ScriptedPawn(dropped).Orders = P_Orders;
	else
		ScriptedPawn(dropped).GotoState('Attacking');
	
	if (P_OrderTag != '')
		ScriptedPawn(dropped).OrderTag = P_OrderTag;
	
	if (P_Health > 0)
		ScriptedPawn(dropped).Health = P_Health;
	
	if (P_SightRadius > 0)
		ScriptedPawn(dropped).SightRadius = P_SightRadius;
	
	if (P_Skill > 0)
		ScriptedPawn(dropped).Skill = P_Skill;
	
	if (P_Aggressiveness > 0)
		ScriptedPawn(dropped).Aggressiveness = P_Aggressiveness;
	
	if (P_CombatStyle > 0)
		ScriptedPawn(dropped).CombatStyle = P_CombatStyle;
	
	if (P_ReFireRate > 0)
		ScriptedPawn(dropped).ReFireRate = P_ReFireRate;
	
	if (P_RangedProjectile != None)
		ScriptedPawn(dropped).RangedProjectile = P_RangedProjectile;
	
	if (P_ProjectileSpeed > 0)
		ScriptedPawn(dropped).ProjectileSpeed = P_ProjectileSpeed;
	
	if (P_AccelRate > 0)
		ScriptedPawn(dropped).AccelRate = P_AccelRate;
	
	if (P_GroundSpeed > 0)
		ScriptedPawn(dropped).GroundSpeed = P_GroundSpeed;
	
	if (P_AirSpeed > 0)
		ScriptedPawn(dropped).AirSpeed = P_AirSpeed;
	
	if (P_JumpZ > 0)
		ScriptedPawn(dropped).JumpZ = P_JumpZ;
	
	if (P_WaterSpeed > 0)
		ScriptedPawn(dropped).WaterSpeed = P_WaterSpeed;
	
	if (P_Event != '')
		ScriptedPawn(dropped).Event = P_Event;
	
	Super.Destroyed();
}

defaultproperties
{
     RemoteRole=ROLE_SimulatedProxy
}
