// =============================================================================
// Parent   : BBoyShare.B_NavigationPoint
// Package  : BBoyShare
// Class    : B_TraceSensor
//
// Author   : Boom-Boy
// Homepage : http://mth.or.tp/
//
// Version  : 1.0
// =============================================================================

class B_TraceSensor extends B_NavigationPoint;

var(Sensor) name NextSensorName;
var(Sensor) name SensorName;
var(Sensor) bool bNoTrace;

var bool bDoTraceOnce;

function PostBeginPlay() {
	
	bDoTraceOnce = false;
	if (bNoTrace || Event == '' || SensorName == '') {
		GotoState('Finish');
	}
}

function SendEvent(Actor Hit) {
	
	local B_TraceTrigger Trig;
	
	foreach AllActors(class'B_TraceTrigger', Trig, Event) {
		
		if (Trig.IsRelevant(Hit)) {
			Trig.DoTouchProcess(Hit);
			bDoTraceOnce = Trig.bDoProcessOnce; 
		}
	}
	
	if (bDoTraceOnce)
		GotoState('Finish');
}

Auto State Waiting
{
	function Tick(float DT) {
		
		local B_TraceSensor Sensor;
		local Actor Hit;
		local Vector HitLocation, HitNormal;
		
		foreach AllActors(class'B_TraceSensor', Sensor) {
			if (NextSensorName == Sensor.SensorName)
				break;
		}
		
		if (Sensor != None) {
			Hit = Trace(HitLocation, HitNormal, Sensor.Location, Location, true);
			if (Hit != None && !Hit.IsA('B_TraceSensor')
				&& !Hit.IsA('B_TraceTrigger') && Hit.class != class'LevelInfo'
			) {
				SendEvent(Hit);
			}
		}
	}
}

State Finish
{

}

defaultproperties
{
}
