// =============================================================================
// Parent   : Engine.Trigger
// Package  : BBoyShare
// Class    : B_TraceTrigger
//
// Author   : Boom-Boy
// Homepage : http://mth.or.tp/
//
// Version  : 1.0
// =============================================================================

class B_TraceTrigger extends Trigger;

var bool bDoProcessOnce;

function Touch(Actor Other) {
	
	return;
}

function UnTouch(Actor Other) {
	
	return;
}

function TakeDamage(
	int Damage,
	Pawn InstigatedBy,
	Vector HitLocation,
	Vector Momentum,
	name DamageType
) {
	return;
}

function DoTouchProcess(Actor Hit) {
	
	local Actor A;
	
	if (bDoProcessOnce)
		return;
	
	if( IsRelevant( Hit ) ) {
		
		if ( ReTriggerDelay > 0 ) {
			
			if ( Level.TimeSeconds - TriggerTime < ReTriggerDelay )
				return;
			TriggerTime = Level.TimeSeconds;
		}
		
		// Broadcast the Trigger message to all matching actors.
		if( Event != '' ) {
			foreach AllActors( class 'Actor', A, Event )
				A.Trigger( Hit, Hit.Instigator );
		}
		
		if ( Hit.IsA('Pawn') && (Pawn(Hit).SpecialGoal == self) )
			Pawn(Hit).SpecialGoal = None;
		
		if( Message != "" ) {
			
			// Send a string message to the toucher.
			Hit.Instigator.ClientMessage( Message );
		}
		
		if( bTriggerOnceOnly ) {
			
			// Ignore future touches.
			SetCollision(False);
			bDoProcessOnce = true;
		} else if ( RepeatTriggerTime > 0 ) {
			
			SetTimer(RepeatTriggerTime, false);
		}
	}
}

defaultproperties
{
}
