// =============================================================================
// Parent   : BBoyShare.B_Effectors
// Package  : BBoyShare
// Class    : B_WaterfallGen
//
// Author   : Boom-Boy
// Homepage : http://mth.or.tp/
//
// Version  : 1.0
// !! DO NOT USE !!
// =============================================================================

class B_WaterfallGen extends B_Effectors;

var() int FallZ;
var() float FlashGlow;
var float FlashTime;
var() float SpawnScale;
var() int Density;

simulated function PostBeginPlay() {
	
	super.PostBeginPlay();
	
	SetTimer(0.1, true);
}

simulated function PostNetBeginPlay() {
	
	super.PostNetBeginPlay();
	
	SetTimer(0.1, true);
}

simulated function Timer() {
	
	local vector v;
	local B_WaterfallEffect FE;
	local int i;
	
	for (i = 0; i < Density; i++) {
		v = vect(0, 0, 0);
		if (FRand() > 0.5) {
			v.X += Rand(16 + int(SpawnScale));
			v.Y += Rand(16 + int(SpawnScale));
		} else {
			v.X -= Rand(16 + int(SpawnScale));
			v.Y -= Rand(16 + int(SpawnScale));
		}
		v.Z -= 1;
		FE = spawn(class'B_WaterfallEffect', , , Location - v * CollisionHeight / 2);
		FE.DrawScale = SpawnScale;
		FE.Velocity.Z -= 100 * SpawnScale + FallZ * FlashTime;
	}
}

defaultproperties
{
     FallZ=1024
     FlashGlow=1.000000
     FlashTime=0.500000
     SpawnScale=1.000000
     Density=8
     CollisionRadius=8.000000
     CollisionHeight=8.000000
}
